; Power-ups che scrollano ogni tanto al centro dello schermo?
; Player Speed, Life, Stop Scroll, Fuel, ...
; Ma anche malus: Increase Scroll, Decrease Player Speed, Decrease Fuel, ...
; Poi barra del Thrust che e' limitato e decrementa.

; * Far muovere il giocatore ogni 2 frames (solo per le X ovviamente)
; - Se il carburante sta finendo il giocatore si muove + lentamente...
; * Il "nemico" sulla prima fascia sara' del cibo, e sara' solo _uno_ sprite
; * Preso il cibo, sull prima fascia appare uno o piu' nemici veri e scompare la linea sotto
; - Nei livelli + avanti, si potrebbe far abbassare la linea mano a mano che il giocatore va giu' cosi' non puo'
;   piu' tornare su ed e' + difficile!
; - Quando il player deve tornare alla base, la base lampeggia per farglielo capire.
; - Si potrebbe fare un livello dove, dopo sganciato, non si puo' piu' muovere destra/sinistra ma solo su/giu!
; - Fasce di nemici che scompaiono...
; - Nemici che si muovono secondo una sine table avanti e indietro (o anche sono in una direzione, accelerando e decelerando)
; - Nemici che si muovono in maneira casuale o intelligente
; - Nemici che, se colpiti, non ti distruggono ma ti bloccano oppure ti rimandano indietro di una fascia
; - "Zapper" o altro nemico che si aggira al livello della base e ti killa se stai li'

; TODO a breve:
; - Collisioni con tutti
; - Quando collide con le bombe da distruggere, togliere quella distrutta
; - Lancio del player e stats (fuel, vite, livello)

;
; How to Draw A Playfield.
; by Nick Bensema  6:35PM  9/10/98
;
; Atari 2600 programming is different from any other kind of programming
; in many ways.  Just one of these ways is the flow of the program.
;
; Since the CPU must hold tha TIA's hand through all graphical operations,
; the flow ought to go like this:
;
; Clear memory and registers
; Set up variables
; Loop:
;    Do the vertical blank
;    Do game calculations
;    Draw screen
;    Do more calculations during overscan
;    Wait for next vertical blank
; End Loop.
;    
; What I will do is create an outline, and explain everything I can.
; This program will display "HELLO" and scroll it down the screen.
;
; In writing this program, I will take the opportunity to show you
; how a few simple modifications can completely change a program's
; appearance or behavior.  I will invite you to comment out a few
; lines of code, and alter others, so that you can observe the results.
; 
; I will be using DASM for now.  Conversion to A65 should be trivial.
;
	processor 6502
	include vcs.h

	org $F000

MAX_STRIPE = 6
MIN_STRIPE = 1	; Usato solo per il movimento del player

TOTAL_STRIPES = 7

INITIAL_STRIPE = 0	; Stripe in cui si trova il player all'inizio

PLAYERDELAY_DEFAULT = 2	; 1 = ogni frame

PLAYER_INITIALLIVES = 3

;ENEMYLINECOLOR_DEFAULT = $42
ENEMYLINECOLOR_DEFAULT = $f4

PLAYERX_DEFAULT = 80

TOTAL_LEVELS = 3

FUELLEVEL_DEFAULT = 36	; Starting fuel level
FUELDELAY_DEFAULT = 40	; Fuel decrease delay (in frames)
FUELCOLOR_OK = $d4
FUELCOLOR_WARNING = $1a
FUELCOLOR_DANGER = $42

Temp = $80

playerX = $81
plrPos = $82
plrOff = $83
plrStripe = $84
plrAnim = $85
plrAnimOff = $86

enemyShapeLo = $87
enemyShapeHi = $88

spr0x = $89

; $8a libero

;spr0y = $8a
spr0pos = $8b	; Posizione x, ossia un numero da $0 a $d per l'offset sullo schermo
spr0off = $8c	; Offset x per HMPn, da $80 (-8) a $70 (+7)

PlayerDelay = $8d	; Flip/Flop per muovere il player un frame si ed uno no (1 no, 0 si)

PS_temp = $8e

EnemyLineColor = $8f

PlayerDelayDefault = $90

ScreenY = $91	; Y totali (iniziale: 192)
ScreenStripeY = $92	; Y nella stripe (iniziale: 8)
Stripes = $93	; Numero della stripe corrente (iniziale: MAX_STRIPE)

Joystick0 = $94
OldJoystick0 = $95

enemyDelays = $96	; Array of MAX_STRIPES con i delay di EnemyMoves (uno per Stripe), ci vanno i delay di EnemyMoves
enemyPos = $9d	; Array of MAX_STRIPES con i POS dei nemici, precalcolati (uno per Stripe)
enemyOff = $a4	; Array of MAX_STRIPES con gli OFFset dei nemici, precalcolati (uno per Stripe)
enemyX = $ab	; Array of MAX_STRIPES che ovviamente contiene le X dei nemici (una per Stripe)
; Totale: 24 bytes :(

; Libero da $b2
GoingUp = $b2	; 0: UP - 1: DOWN

basePos = $b3	; posizione e offset della base in basso
baseOff = $b4
baseX = $b5

plrLives = $b6
plrCollide = $b7
plrExploding = $b8	; 0 se non sta esplodendo, 1 se sta esplodendo
plrDeathAnim = $b9
plrDeathAnimOff = $ba
plrNextLife = $bb

EnemyLineColorDefault = $bc

ChangingDirection = $bd

SaveFirstEnemyX = $be
NewFirstEnemyX = $bf

LevelPtrLo = $c0
LevelPtrHi = $c1

CurrentLevel = $c2

EnemyMovesPtrLo = $c3
EnemyMovesPtrHi = $c4

EnemyDirectionsPtrLo = $c5
EnemyDirectionsPtrHi = $c6

ChangeLevel = $c7

ScanLine = $c8
ScanPix = $c9
PFColorRAM = $ca
ScanPixVal = $cb

PfFuel = $cc	; Fuel indicator (6 bytes: $cc .. $d1)

; Free starting from $d2
FuelLevel = $d2
FuelDelay = $d3
FuelColor = $d4

Start
;
; The 2600 powers up in a completely random state, except for the PC which
; is set to the location at $FFC.  Therefore the first thing we must do is
; to set everything up inside the 6502.
;
	SEI  ; Disable interrupts, if there are any.
	CLD  ; Clear BCD math bit.
;
; You may feel the need to use the stack, in which case:
;
	LDX  #$FF
	TXS  ; Set stack to beginning.
;
; Now the memory and TIA registers must be cleared.  You may feel the
; need to write a subroutine that only clears out a certain section of
; memory, but for now a simple loop will suffice.
;
; Since X is already loaded to 0xFF, our task becomes simply to ocunt
; everything off.
;
	LDA #0
B1      STA 0,X
	DEX
	BNE B1
;
; The above routine does not clear location 0, which is VSYNC.  We will
; take care of that later.
;
; At this point in the code we would set up things like the data
; direction registers for the joysticks and such.  
;

;	JSR InitIntroScreen
MainLoopIntroScreen
	JSR VerticalBlank
	JSR DrawIntroScreen
;	JMP DrawIntroScreen
	JSR OverScan
	LDA INPT4		; Check fire button
	BMI MainLoopIntroScreen	; Fire button not pressed
;	JMP MainLoopIntroScreen

	JSR  GameInit

;
; Here is a representation of our program flow.
;
MainLoop
	JSR  VerticalBlank ;Execute the vertical blank.
	JSR  CheckSwitches ;Check console switches.
	JSR  GameCalc      ;Do calculations during Vblank
	JSR  DrawScreen    ;Draw the screen
	JSR  OverScan      ;Do more calculations during overscan
	JMP  MainLoop      ;Continue forever.
;
; It is important to maintain a stable screen, and this routine
; does some important and mysterious things.  Actually, the only
; mysterious part is VSYNC.  All VBLANK does is blank the TIA's
; output so that no graphics are drawn; otherwise the screen
; scans normally.  It is VSYNC which tells the TV to pack its
; bags and move to the other corner of the screen.
;
; Fortunately, my program sets VBLANK at the beginning of the
; overscan period, which usually precedes this subroutine, so
; it is not changed here.
;
VerticalBlank  ;*********************** VERTICAL BLANK HANDLER
	LDX  #0
	LDA  #2
	STA  WSYNC  
	STA  WSYNC
	STA  WSYNC
	STA  VSYNC ;Begin vertical sync.
	STA  WSYNC ; First line of VSYNC
	STA  WSYNC ; Second line of VSYNC.
;
; But before we finish off the third line of VSYNC, why don't we
; use this time to set the timer?  This will save us a few cycles
; which would be more useful in the overscan area.
;
; To insure that we begin to draw the screen at the proper time,
; we must set the timer to go off just slightly before the end of
; the vertical blank space, so that we can WSYNC up to the ACTUAL
; end of the vertical blank space.  Of course, the scanline we're
; going to omit is the same scanline we were about to waste VSYNCing,
; so it all evens out.
;
; Atari says we have to have 37 scanlines of VBLANK time.  Since
; each scanline uses 76 cycles, that makes 37*76=2888 cycles.
; We must also subtract the five cycles it will take to set the
; timer, and the three cycles it will take to STA WSYNC to the next
; line.  Plus the checking loop is only accurate to six cycles, making
; a total of fourteen cycles we have to waste.  2888-14=2876.
;
; We almost always use TIM64T for this, since the math just won't
; work out with the other intervals.  2880/64=44.something.  It
; doesn't matter what that something is, we have to round DOWN.
;
	LDA  #44
	STA  TIM64T
;
; And now's as good a time as any to clear the collision latches.
;
	LDA #0
	STA CXCLR
;
; Now we can end the VSYNC period.
;
	STA  WSYNC ; Third line of VSYNC.
	STA  VSYNC ; (0)
;
; At this point in time the screen is scanning normally, but
; the TIA's output is suppressed.  It will begin again once
; 0 is written back into VBLANK.
;
	RTS  
;
; Checking the game switches is relatively simple.  
;
; It just so happens that I'm not going to check any game switches
; here.  I'm just going to set up the colors, without even checking
; the B&W switch!  HA!
;
CheckSwitches ;*************************** CONSOLE SWITCH HANDLER
	LDA #0
	STA COLUBK  ; Background will be black.
	LDA SWCHA       ;Read joystick 0
	STA Joystick0   ;Store for later use

	LDA SWCHB
	AND #%00000001
	BNE NoResetGame
	JSR GameInit	; Se RESET e' premuto, reinizializza il gioco
NoResetGame

; Nuovo livello?
	LDA ChangeLevel
	BEQ NoChangeLevel
		INC CurrentLevel	; Ocio, questo prima sballava...
	JSR NewLevel
NoChangeLevel
	RTS

; Mettere in X la posizione X dello sprite in pixel
CalcSprXPos
	;lda spr0x	; absolute X pixel
	TXA	; absolute X pixel
	lsr
	lsr
	lsr
	lsr
	tay	; /16
	
	sta PS_temp
	
	;lda spr0x
	TXA
	and #15
	clc
	adc PS_temp
	cmp #15
	
	tya
	adc #0
	tay
	sty PS_temp
	iny
	iny
	iny
	
	;lda spr0x
	TXA
	and #15
	clc
	adc PS_temp	; calculate the remainder for the /15
	; Use remainder for fine adjustment
	eor #15
	sbc #7	; -8 to +7
	asl
	asl
	asl
	asl
	
;	sta HMP0                      ; fine movement
;	sta HMP1                      ; fine movement
;	sty spr0pos
;	iny
;	sty spr1pos

;	RETURN:
;	A: Fine Movement (offset)
;	Y: Position
	RTS

;
; Minimal game calculations, just to get the ball rolling.
;
GameCalc ;******************************* GAME CALCULATION ROUTINES
;;	INC PlayfieldY   ;Inch up the playfield
;	INC spr0x
;	LDA spr0x
;	CMP #160
;	BCC NoZeroSpr0x
;	LDA #0
;	STA spr0x
;NoZeroSpr0x

; Resetta il colore per la fascia sulla prima linea
	;LDA #ENEMYLINECOLOR_DEFAULT
	LDA EnemyLineColorDefault
	STA EnemyLineColor

; Animazione (flicker) al momento che prende la frutta.
	LDA ChangingDirection
	BEQ NotChangingDirection
	; Swappa velocemente le tables
	DEC ChangingDirection
	BNE StillChangingDirection
	LDA #0
	STA plrExploding
	LDA #8
	STA GoingUp	; Alla fine mette il nuovo set di nemici (Fase finale del ChangeDirection)
	LDY #MAX_STRIPE
	LDA NewFirstEnemyX
	STA enemyX,Y
	JMP NotChangingDirection
StillChangingDirection
	LDA #0
	STA plrExploding
	LDA GoingUp
	BEQ ChangeDirectionAnim2
	LDA #0
	STA GoingUp	; Rimette il vecchio set di nemici (Anim)
	LDY #MAX_STRIPE
	LDA SaveFirstEnemyX
	STA enemyX,Y
	JMP MovePlayerX
ChangeDirectionAnim2
	LDA #8
	STA GoingUp	; Mette il nuovo set di nemici (Anim)
	LDY #MAX_STRIPE
	LDA NewFirstEnemyX
	STA enemyX,Y
	JMP MovePlayerX
NotChangingDirection
; Se sta animando l'esplosione del giocatore, non leggere il joy e non muovere niente sullo schermo

; -- Controllo se il player e' sulla prima fascia. Se c'e' e la frutta e' presente, agisce di conseguenza.
	LDA plrExploding
	BEQ NoExploding		; Se non sta esplodendo, allora prosegue normalmente leggendo il joystick
	LDA plrStripe
	CMP #MAX_STRIPE+1
	BEQ PlayerFirstStripeCollide	; Se collide ed e' sulla prima fascia in alto..
	JMP MovePlayerX		; E' importante che la X del player sia sempre calcolata anche mentre esplode!
PlayerFirstStripeCollide	; Collisione con la prima riga..
	LDA GoingUp
	BEQ NoExplodingFirstLine	; Se stavamo andando su e collide con la prima fascia, allora non esplode
	JMP MovePlayerX
NoExplodingFirstLine
	; Presa la frutta:
	LDA #8
	STA GoingUp		; Da ora in poi il player deve andare giu'! (ci mette 8 cosi' poi lo usa come incremento all'array dei nemici)
	LDA #0
	STA plrExploding	; Non lo fa esplodere
	STA EnemyLineColorDefault
	LDA #100
	STA ChangingDirection
	LDY #MAX_STRIPE
	LDA enemyX,Y
	STA SaveFirstEnemyX
	LDA playerX
	CMP #80		; Secondo la posizione del giocatore al momento che prende la frutta, posizioniamo il nemico che si viene a creare sulla prima linea
	BCC PlayerPos1
	LDA #16
	STA NewFirstEnemyX	; Nemico in posizione sinistra (16)
	JMP PlayerPos2
PlayerPos1
	LDA #110		; Nemico in posizione destra (110)
	STA NewFirstEnemyX

PlayerPos2

NoExploding
; -- Decrease fuel level --

	DEC FuelDelay
	BNE NoZeroFuelDelay
	; Decrease fuel level (and reset fuel delay)
	LDA #FUELDELAY_DEFAULT
	STA FuelDelay
	DEC FuelLevel
	LDA PfFuel+3
	BEQ Fuel4
	ASL
	STA PfFuel+3
	JMP NoZeroFuelDelay
Fuel4
	LDA PfFuel+4
	BEQ Fuel3
	LSR
	STA PfFuel+4
	JMP NoZeroFuelDelay
Fuel3
	LDA PfFuel+5
	BEQ Fuel2
	ASL
	STA PfFuel+5
	JMP NoZeroFuelDelay
Fuel2
	LDA PfFuel+2
	BEQ Fuel1
	LSR
	STA PfFuel+2
	JMP NoZeroFuelDelay
Fuel1
	LDA PfFuel+1
	BEQ Fuel0
	ASL
	STA PfFuel+1
	JMP NoZeroFuelDelay
Fuel0
	LDA PfFuel+0
	BEQ EndOfFuel
	LSR
	AND #%11000000
	STA PfFuel+0
	JMP NoZeroFuelDelay
EndOfFuel
	; Do something here if fuel has finished...
NoZeroFuelDelay

	LDA FuelLevel
	CMP #10
	BNE NoPlayerSlowDown
	LDA #3
	STA PlayerDelayDefault	; Slow down player if fuel is low
	LDA #FUELCOLOR_DANGER
	STA FuelColor
NoPlayerSlowDown
	CMP #15
	BNE NoChangeFuelColor
	LDA #FUELCOLOR_WARNING
	STA FuelColor
NoChangeFuelColor
; -------------------------

; --
; Joystick
	DEC PlayerDelay
	LDA PlayerDelay
;	BNE PlayerCanMoveX
	BEQ PlayerCanMoveX
	LDA Joystick0
	AND #%00111111
	STA Joystick0
;	DEC PlayerDelay
	JMP ContinueJoystick
PlayerCanMoveX
;	INC PlayerDelay		; Fino qui serve a far muovere sulle X a frames alterni
;	LDA #PLAYERDELAY_DEFAULT
	LDA PlayerDelayDefault
	STA PlayerDelay		; Fino qui serve a far muovere sulle X a frames alterni
ContinueJoystick	
	LDA Joystick0
;	AND #$F0
	BMI NoJoyRight
	LDX #148
	CPX playerX
	BEQ NoJoyRight
	; Azione RIGHT
	INC playerX
NoJoyRight
	ROL
	BMI NoJoyLeft
	LDX #12
	CPX playerX
	BEQ NoJoyLeft
	; Azione LEFT
	DEC playerX
NoJoyLeft
;-- Ignora UP/DOWN se nel frame precedente e' andato UP o DOWN
		TAX		; Se e' alla linea sotto la frutta, legge il joy su/giu' solo se e' allineato con la frutta
;			LDA GoingUp	; Legge su/giu' se si trova sulla prima riga e sta andando giu' (ossia se cerca di connettersi alla base)
;			BEQ CantConnectToBase
;			LDA #MIN_STRIPE
;			CMP plrStripe
;			BEQ OkJoyUpDown
CantConnectToBase
		LDA GoingUp
		CMP #8
		BEQ ProcessJoyUpDown
		LDY #MAX_STRIPE
		LDA enemyX,Y
		CMP playerX
		BEQ OkJoyUpDown
		CLC
		ADC #1
		CMP playerX
		BNE ProcessJoyUpDown
OkJoyUpDown
		LDA OldJoystick0
		ORA #%00110000
		STA OldJoystick0
ProcessJoyUpDown
		TXA
	TAX
	LDA OldJoystick0
	BIT J0_Up
	BEQ NoStick
	BIT J0_Down
	BEQ NoStick

	TXA
;--
	ROL
	BMI NoJoyDown
	LDX #MIN_STRIPE
	CPX plrStripe
	BCS MaybeNoJoyDown
	JMP OkJoyDown
MaybeNoJoyDown
	LDX GoingUp
	BEQ NoJoyDown
MaybeNoJoyDown2
	; Aggancio alla base - controllare posizione player, che sia allineato con la base...
	; e far avanzare di livello!
	TAX	; Save A
	LDA baseX
	CLC
	ADC #8
	CMP playerX
	BCC NoJoyDown
	LDA baseX
	SBC #8
	CMP playerX
	BCS NoJoyDown

	LDA baseX
	STA playerX	; Agganciamento: il player si posiziona sulla base
	;INC CurrentLevel	; Prossimo livello...
	LDA #1
	STA ChangeLevel	; Cambiare il livello!
;	LDX #0
;	STX GoingUp
	TXA	; Restore A
OkJoyDown
	; Azione DOWN
	DEC plrStripe
NoJoyDown
	ROL
	BMI NoJoyUp
	LDX #MAX_STRIPE
;		INX
	CPX plrStripe
	BCC NoJoyUp
	; Azione UP
		LDA GoingUp
		BNE OkJoyUp	; Se stiamo andando giu', permetti sempre di far andare il giocatore sulla prima fascia

		LDA plrStripe	; Se e' alla linea sotto la frutta, sposta in su solo se e' allineato con la frutta
		CMP #MAX_STRIPE
		BNE OkJoyUp
		TAY
		LDA GoingUp
		CMP #8
		BEQ NoJoyUp
		LDA enemyX,Y
		CMP playerX
		BEQ OkJoyUp
		CLC
		ADC #1
		CMP playerX
		BNE NoJoyUp
OkJoyUp
	INC plrStripe
NoJoyUp

NoStick
;	LDA INPT4	; Togliere il commento a queste 2 linee x leggere il pulsante di fuoco
;	BMI NoJoyFire
	; Azione del fuoco va qui
NoJoyFire

	LDA Joystick0
	STA OldJoystick0	; Salva la posizione del joy per il prossimo frame in modo che possiamo controllare com'era nel frame precedente

;	DEC spr0y
;	LDA spr0y
;	CMP #$02
;	BCS NoZeroSpr0Y		; BCS: Salta se A >= alla memoria
	;BPL NoZeroSpr0Y
	;BNE NoZeroSpr0Y
;	LDA #192
;	STA spr0y
;NoZeroSpr0Y	

; Movimento X Nemici
;	LDX spr0x	; Per ora calcoliamo una sola X per tutti i nemici...
;	JSR CalcSprXPos
;	STA HMP1
;	STY spr1pos

; Sposta i nemici secondo i Delay e gli Incrementi/Direzioni
	LDX MAX_STRIPE
MoveEnemyX
	DEC enemyDelays,X
	BNE NoMoveEnemyX
	TXA
	TAY	; X va in Y perche' l'indirizzamento (xxx),Y si fa solo con Y !!
	LDA (EnemyMovesPtrLo),Y	; Questo va fatto con Y per forza... :(
;	LDA EnemyMoves,X
	STA enemyDelays,X

	TXA
	TAY
	;LDA EnemyDirections,X	; Incremento in frames
	LDA (EnemyDirectionsPtrLo),Y
	STA Temp
	LDA enemyX,X
	CLC	; <--- FONDAMENTALE prima di un ADC !!!!!
	ADC Temp
	CMP #160
	BCC NoZeroEnemyX
	LDA #0
	JMP NoResetEnemyX
NoZeroEnemyX
	CMP #1
	BCS NoResetEnemyX
	LDA #160
NoResetEnemyX
	STA enemyX,X
NoMoveEnemyX
	DEX
	BPL MoveEnemyX

; Movimento X Player
MovePlayerX
	LDX playerX
	JSR CalcSprXPos
	STA HMP0
	STA plrOff
	STY plrPos
; Copia la posizione del player in quella della base, ma solo se il player si trova sulla base! (ossia plrStripe = 0)
	LDA plrStripe
	BNE NoCopyPlayerBase
	LDA plrPos
	STA basePos
	LDA plrOff
	STA baseOff
	LDA playerX
	STA baseX
NoCopyPlayerBase

; Calcola i Movimenti X per tutte le fasce di Nemici
	LDX MAX_STRIPE
CalcEnemyX
	STX Temp
	LDA enemyX,X
	TAX
	JSR CalcSprXPos
	LDX Temp
	STA enemyOff,X
	STY enemyPos,X
	DEX
	BPL CalcEnemyX
	
NoSprAddPos
;	STA HMCLR	; Clear HMOVE
;	LDA spr0off	; 
;		INC spr0off
;		LDA spr0off

;	LDX ShiftTabPos
;	LDA ShiftTab,X
;	STA HMP0	; Shift X dello sprite 0
;	INC ShiftTabPos
;	LDA ShiftTabPos
;	AND #15
;	STA ShiftTabPos

	;LDA #0
	;STA Spr0ClrCnt

;	LDA #192
;	STA ScreenY

; Animazione Player 1
;	LDA GoingUp
;	BNE PlayerNormalAnim	; Se c'e' collisione ma GoingUp sta ad 1 vuol dire che il giocatore sta andando verso il basso
; Esplosione?
	LDA #0
	STA plrNextLife		; We have to zero this, somewhere... it's just a one-time switch!

	LDA plrExploding
	BEQ PlayerNormalAnim	; Se non sta esplodendo...
	; Sta esplodendo: animazione
	LDX plrDeathAnim
	LDA PlayerDeath1Anim,X
	STA plrAnimOff
	DEC plrDeathAnim
	BNE NoZeroPlayerAnim

	LDA PlayerDeath1Anim
	STA plrDeathAnim	; Resetta l'animaizione della morte
	LDA Player1Anim
	STA plrAnim
	LDA #0
	STA plrExploding	; fine esplosione
	DEC plrLives
		LDA #0
		STA GoingUp
		;LDA #FUELLEVEL_DEFAULT
		;STA FuelLevel
		;LDA FUELDELAY_DEFAULT
		;STA FuelDelay
		;JSR PlayerDeath
		JSR InitFuel
;	LDA #1
;	STA plrNextLife
	LDA #ENEMYLINECOLOR_DEFAULT
	STA EnemyLineColorDefault
	LDA #INITIAL_STRIPE
	STA plrStripe	; Fascia in cui si trova il giocatore
	LDA baseX
	STA playerX

	; Next Life

	JMP NoZeroPlayerAnim
PlayerNormalAnim	; Animazione normale del player (non esplosione)
	LDX plrAnim
	LDA Player1Anim,X
	STA plrAnimOff
	DEC plrAnim
	BNE NoZeroPlayerAnim
	LDA Player1Anim
	STA plrAnim

NoZeroPlayerAnim

	LDA #1
	STA VDELP0	; Questo serve per abbassare di una linea P0 senno' si disallinea da P1 dato che disegno uno sprite su una linea e uno sull'altra
	RTS

; ----- Player Dies: reset veriables... -----
;PlayerDeath
;	JSR InitFuel
;	RTS

; ----- Initialize fuel level and graphics -----
InitFuel
	LDA #%11000000
	STA PfFuel+0
	LDA #%11111111
	STA PfFuel+1
	LDA #%11111111
	STA PfFuel+2
	LDA #%11000000
	STA PfFuel+3
	LDA #%11111111
	STA PfFuel+4
	LDA #%11111111
	STA PfFuel+5

	LDA #FUELLEVEL_DEFAULT
	STA FuelLevel
	LDA #FUELDELAY_DEFAULT
	STA FuelDelay

	LDA #FUELCOLOR_OK
	STA FuelColor
	RTS

;
; This is the scariest thing I've done all month.
;
DrawScreen ;**************************** SCREEN DRAWING ROUTINES
	LDA INTIM
	BNE DrawScreen ; Whew!
	STA WSYNC
;	STA HMOVE
	STA VBLANK  ;End the VBLANK period with a zero.
;
; Now we can do what we need to do.  What sort of playfield do
; we want to show?  A doubled playfield will work better than
; anything if we either want a side scroller (which involves some
; tricky bit shifting, usually) or an asymmetrical playfield (which
; we're not doing yet).  A mirrored playfield is usually best for
; vertical scrollers.  With some creativity, you can use both in your
; game.
;
; The "score" bit is useful for drawing scores with playfield graphics
; as Combat and other early games do.  It can also create a neat effect
; if you know how to be creative with it.  One useful application of
; score mode would be always having player 1 on the left side, and
; player 0 on the right side.  Each player would be surrounded in the
; opposite color, and the ball graphic could be used to stand out
; against either one.  On my 2600jr, color from the right side bleeds
; about one pixel into the left side, so don't think it's perfect.
; It's really far from perfect because PC Atari does not implement
; it at all; both sides appear as Player 0's color.  A26 does, though.
;
; To accomodate this, my routine puts color values into
; COLUP0 for the left side, and COLUP1 for the right side.  Change
; the LDA operand to 0 or 1 to use the normal system.  The code in
; the scanning loop accounts for both systems.
;
	;LDA  #2
	LDA  #5		; Playfield tutto dello stesso colore
	STA  CTRLPF
;
; Initialize some display variables.
;

; 192 Scanlines

; Prima linea: inizializziamo un po' di cose...
	LDA #$23
	STA COLUP0
	LDA #0
	STA GRP0	; Sprite 0 nullo
	STA PF1
	STA PF2
	STA COLUPF	; Background nero
	LDA #%00110000
	STA PF0

; -- Inizio Fasce --
	LDA TOTAL_STRIPES	; 7
;	CLC
;	SBC #1	; Una fascia in meno perche' la prima la gestiamo a parte..
	STA Stripes	; Numero di fasce

StripesLoop
; ----------- Fascia ------------
;	LDX spr0pos
;	LDY spr1pos

; Caricamento Offset e Pos Nemici (da array) e Player. Player solo POS.
	LDX Stripes
	DEX
	LDA enemyOff,X
	STA HMP1
	LDY enemyPos,X

	;LDY spr1pos	; Sprite 1 pos (nemici)
	LDX plrPos	; Sprite 0 pos (player)
	STA WSYNC

; Posizioniamo i nostri sprites...
Spr0XposLoop1
	DEX
	BPL Spr0XposLoop1
	STA RESP0	; Attiva lo sprite a questa pos. secondo i cicli passati
	STA WSYNC		; Arriva alla fine della linea

Spr1XposLoop1
	DEY
	BPL Spr1XposLoop1
	STA RESP1	; Attiva lo sprite a questa pos. secondo i cicli passati
	STA WSYNC		; Arriva alla fine della linea
	STA HMOVE

; --- 8 scanlines * 2
	LDA #192
	STA ScreenY
	LDA #8
	STA ScreenStripeY

	LDA Stripes	; 8
	LDX GoingUp
	BEQ PlayerGoingDown
	CLC
	ADC #7
PlayerGoingDown
	ASL		; 8*2 = 16
		ASL		; 8*2 = 16
	TAY
	DEY
	;LDA LevelData,Y
	LDA (LevelPtrLo),Y
	STA enemyShapeLo	; Ultimo byte in Lo
	DEY
	;LDA LevelData,Y
	LDA (LevelPtrLo),Y
	STA enemyShapeHi	; Carico il puntatore alla grafica del nemico in enemyShapeLo-Hi

		DEY
		;LDA LevelData,Y
		LDA (LevelPtrLo),Y
		STA NUSIZ1
	LDX plrAnimOff	; Offset Player
	LDY #0	; Offset Nemico

	STA WSYNC
ScanLoop1
;	LDA ScreenStripeY
;	CMP #1
;	BNE NoBgColor
;	LDA EnemyLineColor
;	STA COLUBK
;NoBgColor
	LDA Stripes
	CMP plrStripe
	BNE NoDrawPlayer
	LDA Player1Shape,X
	STA GRP0	; store this line of data in player graphic 0 register. Questo lo posso fare quando voglio e rimane... l'importante e' scrivere in RESP0 al momento che voglio la linea dello sprite!
	INX
NoDrawPlayer
	STA WSYNC

;	LDA Mine1Shape,Y
	LDA (enemyShapeLo),Y
	STA GRP1	; Se VDELP0 e' attivo, lo sprite 0 verra' mostrato solo al momento della scrittura in GRP1 !!! cosi' compaiono entrambi gli sprites sulla stessa scanline... ma ocio ai colori!
	INY
;	LDA Mine1Shape,Y	; 4
	LDA (enemyShapeLo),Y
	STA COLUP1
	LDA Player1Shape,X
	STA COLUP0
	INX
	INY
	STA WSYNC

	LDA ScreenStripeY
	CMP #1
	BNE NoBgColor
	LDA EnemyLineColor
	STA COLUBK
NoBgColor

	DEC ScreenStripeY
	BNE ScanLoop1
	STA WSYNC	; Un'altra linea...

	LDA #0
	STA GRP0
	STA GRP1
; ----- Fine Fascia -----

;	LDA #0
	STA COLUBK
	STA EnemyLineColor

;	LDA #%00000110	; 3 sprite, distanza massima
;	STA NUSIZ1

;		INC spr0pos
	DEC Stripes	; Finita una fascia
	BEQ EndStripesLoop	; Jump al loop delle fasce
	JMP StripesLoop
EndStripesLoop
; ------------------- Terreno ---------------------
;	LDA #%00000000
;	STA NUSIZ1
	LDX basePos	; Sprite 0 pos (player)
	LDA baseOff
	STA HMP0
	STA WSYNC

Spr0XposLoop2
	DEX
	BPL Spr0XposLoop2
	STA RESP0	; Attiva lo sprite a questa pos. secondo i cicli passati
	STA WSYNC		; Arriva alla fine della linea
	STA HMOVE

	LDA #8
	STA ScreenStripeY
	;LDX plrAnimOff	; Offset Player
	LDX #0
	LDA plrStripe
	BEQ ScanLoop2
	LDX #16		; Se il player e' in una fascia diversa dalla base, prende il frame 2 della base, ossia quello vuoto

ScanLoop2
	LDA PlayerGround1Shape,X
	;STA GRP0	; store this line of data in player graphic 0 register. Questo lo posso fare quando voglio e rimane... l'importante e' scrivere in RESP0 al momento che voglio la linea dello sprite!
	STA GRP0
	INX
	STA WSYNC
	LDA PlayerGround1Shape,X
	STA COLUP0
	INX
	LDA #0
	STA GRP1
	STA WSYNC

	DEC ScreenStripeY
	BNE ScanLoop2

	STA WSYNC
	LDA #0
	STA GRP0
	STA GRP1

; -- Terreno vero e proprio
	LDA #$f4
	STA COLUBK
	STA WSYNC
	LDA #$fa
	STA COLUBK
	STA WSYNC
	LDA #$f8
	STA COLUBK
	STA WSYNC
	LDA #$f4
	STA COLUBK
	STA WSYNC
	LDA #$00
	STA COLUBK
;	LDX #7
	LDX #0

	LDA #0
	STA PF0
	STA PF1
	STA PF2
	;LDA #$d4
	LDA FuelColor
	STA COLUPF	; Removing PF graphics and blanking line 1 scanline before doing the fuel in order to maintain a correct cycle count
	STA WSYNC

; -------------------
;	LDA #$d4
;	STA COLUPF

;	STA WSYNC

	LDA PfFuel,X	; 3
	STA PF0		; 6
	LDA PfFuel+1,X	; 9
	STA PF1		; 12
	LDA PfFuel+2,X	; 15
	STA PF2		; 18

	NOP
	NOP
	NOP

	LDA PfFuel+3,X	; 3
	STA PF0		; 6
	LDA PfFuel+4,X	; 9
	STA PF1		; 12
	LDA PfFuel+5,X	; 15
	STA PF2		; 18


;	LDA PFData0,X           ;[0]+4
;	STA PF0                 ;[4]+3 = *7*   < 23	;PF0 visible
;	LDA PFData1,X           ;[7]+4
;	STA PF1                 ;[11]+3 = *14*  < 29	;PF1 visible
;	LDA PFData2,X           ;[14]+4
;	STA PF2                 ;[18]+3 = *21*  < 40	;PF2 visible

;	nop			;[21]+2
;	nop			;[23]+2
;	nop			;[25]+2
	
;	LDA PFData0b,X          ;[27]+4
;	STA PF0                 ;[31]+3 = *34* 
;	LDA PFData1b,X		;[34]+4
;	STA PF1			;[38]+3 = *41*  
;	LDA PFData2b,X		;[41]+4
;	STA PF2			;[45]+2 = *47*  ; > 46 PF2 no longer visible

	STA WSYNC

; ---- Finish screen...
	LDA #00
	STA COLUPF
	LDA #%00110000	; Restore black border...
	STA PF0
	LDA #0
	STA PF1
	STA PF2
	STA COLUBK
	STA WSYNC

	LDA #$f2
	STA COLUBK
	STA WSYNC

	LDY #15		; Scanlines to finish screen

EndScreenLoop
	STA WSYNC
	DEY
	BNE EndScreenLoop

;
; Clear all registers here to prevent any possible bleeding.
;
	LDA #2
	STA WSYNC  ;Finish this scanline.
	STA VBLANK ; Make TIA output invisible,
	; Now we need to worry about it bleeding when we turn
	; the TIA output back on.
	; Y is still zero.
	LDY 0

	STY PF0
	STY PF1
	STY PF1
	STY GRP0
	STY GRP1
	STY ENAM0
	STY ENAM1
	STY ENABL
	RTS

;
; For the Overscan routine, one might take the time to process such
; things as collisions.  I, however, would rather waste a bunch of
; scanlines, since I haven't drawn any players yet.
;
OverScan   ;***************************** OVERSCAN CALCULATIONS

; -- Read Collisions
	LDA CXPPMM
	;STA plrCollide
	BPL NoCollisions
	LDA plrNextLife
	BNE NoCollisions
	LDA #1
	STA plrExploding
NoCollisions
	STA CXCLR	; Resetta le collisioni dopo averle lette
; --

	LDX #30
KillLines
	STA WSYNC
	DEX
	BNE KillLines
	RTS

;
; GameInit could conceivably be called when the Select key is pressed,
; or some other event.
;
GameInit
	LDA #0
	STA CurrentLevel
	JSR NewLevel

	RTS

; ------------------------------------------------
; --------- Inizializza un nuovo livello ---------
; ------------------------------------------------

NewLevel
;	INC CurrentLevel
	LDA CurrentLevel
	CMP #TOTAL_LEVELS
	BCC NoResetLevels
; -- Resets levels count --
	LDA #0
	STA CurrentLevel
NoResetLevels
	LDA #0

        STA     GRP0	; clear out player graphic 0
        STA     GRP1	; clear out player graphic 1
        STA     ENAM0	; clear out missile 0
        STA     ENAM1	; clear out missile 1
        STA     ENABL	; clear out ball

	STA spr0off

	STA GoingUp
	STA plrExploding
	STA plrNextLife
	STA ChangingDirection

	LDA #5
	STA spr0x

	LDA #INITIAL_STRIPE
	STA plrStripe	; Fascia in cui si trova il giocatore

	LDA #$F0
	STA OldJoystick0

	LDA #PLAYERX_DEFAULT	; Pixel iniziale X sprite player
	STA playerX

	LDA #ENEMYLINECOLOR_DEFAULT
	STA EnemyLineColorDefault

	; -- Init dei puntatori ai dati dei livelli
	; Formula per caricare il puntatore del livello partendo dal numero del livello (che e' 0-based)
	LDA CurrentLevel	; Livello
	ASL	; Livello*2
	TAY
	INY	; Livello+1
	LDA LevelPointers,Y
	STA LevelPtrLo	; Ultimo byte in Lo
	DEY
	LDA LevelPointers,Y
	STA LevelPtrHi

	; Carica il puntatore a EnemyMoves
	LDA CurrentLevel
	ASL
	TAY
	INY
	LDA EnemyMovesPointers,Y
	STA EnemyMovesPtrLo	; Ultimo byte in Lo
	DEY
	LDA EnemyMovesPointers,Y
	STA EnemyMovesPtrHi

	; Carica il puntatore a EnemyDirections
	LDA CurrentLevel
	ASL
	TAY
	INY
	LDA EnemyDirectionsPointers,Y
	STA EnemyDirectionsPtrLo	; Ultimo byte in Lo
	DEY
	LDA EnemyDirectionsPointers,Y
	STA EnemyDirectionsPtrHi

; -- Inizializza l'animazione del player 1
	LDA Player1Anim
	STA plrAnim

; -- Inizializza i movimenti e le posizioni X dei nemici
	LDY MAX_STRIPE
	LDX #0
NewLevel_InitEnemyDelays
	;LDA EnemyMoves,Y
	LDA (EnemyMovesPtrLo),Y
	STA enemyDelays,X
	INX
	DEY
	BPL NewLevel_InitEnemyDelays

	LDY MAX_STRIPE
	LDX #0
NewLevel_InitEnemyX
	LDA EnemyPositions,Y
	STA enemyX,X
	INX
	DEY
	BPL NewLevel_InitEnemyX
; --

	LDA PLAYERDELAY_DEFAULT
	STA PlayerDelayDefault
	STA PlayerDelay

	LDA PLAYER_INITIALLIVES
	STA plrLives

	LDA PlayerDeath1Anim
	STA plrDeathAnim	; Resetta l'animazione della morte

	LDA #0
	STA ChangeLevel

	;LDA #%00000101
	;LDA #%00000011
	;LDA #%00000110	; 3 sprite, distanza massima
	LDA #%00000000
	STA NUSIZ1
	;STA NUSIZ1

	JSR InitFuel

	RTS

;	ORG 	$FF00	; start table at $....


; --------- Intro Screen ----------


;DrawIntroScreen

;	RTS

; Shape, Color
Rock1Shape
	.byte %00111000, $20
	.byte %01001110, $22
	.byte %10111111, $24
	.byte %11111110, $24
	.byte %01111111, $24
	.byte %01111110, $22
	.byte %00011000, $20
	.byte %00000000, $00

Mine1Shape
	.byte %00011000, $14
	.byte %10111101, $16
	.byte %01111110, $18
	.byte %10101011, $18
	.byte %11010101, $18
	.byte %01111110, $18
	.byte %10111101, $16
	.byte %00011000, $14

Ufo1Shape
	.byte %00000000, $00
	.byte %01000010, $40
	.byte %00111100, $42
	.byte %11100111, $46
	.byte %11100111, $46
	.byte %00111100, $42
	.byte %01000010, $40
	.byte %00000000, $00

Ship1Shape
	.byte %10000001, $b4
	.byte %11000011, $b6
	.byte %11011011, $b8
	.byte %11111111, $ba
	.byte %11111111, $ba
	.byte %11011011, $b8
	.byte %11000011, $b6
	.byte %10000001, $b4

Cube1Shape
	.byte %00111111, $a8
	.byte %01100011, $aa
	.byte %11111101, $ac
	.byte %10100101, $ae
	.byte %10100101, $ae
	.byte %10111111, $ac
	.byte %11000110, $aa
	.byte %11111100, $a8

Ball1Shape
	.byte %00011000, $c2
	.byte %00101100, $c4
	.byte %01011110, $c6
	.byte %10111111, $c8
	.byte %11111111, $c8
	.byte %01111110, $c6
	.byte %00111100, $c4
	.byte %00011000, $c2

Circle1Shape
	.byte %00111100, $92
	.byte %01000010, $94
	.byte %10011001, $96
	.byte %10100101, $98
	.byte %10100101, $98
	.byte %10011001, $96
	.byte %01000010, $94
	.byte %00111100, $92

Vertical1Shape
	.byte %00011000, $52
	.byte %00011000, $54
	.byte %00111100, $56
	.byte %11111111, $58
	.byte %11111111, $58
	.byte %00111100, $56
	.byte %00011000, $54
	.byte %00011000, $52

Star1Shape
	.byte %00011000, $e2
	.byte %01011010, $e4
	.byte %00111100, $e6
	.byte %11111111, $e8
	.byte %11111111, $e8
	.byte %00111100, $e6
	.byte %01011010, $e4
	.byte %00011000, $e2

Enemy1Shape
	.byte %10011001, $20
	.byte %01100110, $22
	.byte %11111111, $24
	.byte %11111111, $26
	.byte %01100110, $24
	.byte %10011001, $22
	.byte %11111111, $00
	.byte %11111111, $00

Strawberry1Shape
	.byte %00110100, $e6
	.byte %00011000, $e6
	.byte %00101100, $44
	.byte %01111010, $44
	.byte %01011110, $44
	.byte %00101100, $44
	.byte %00011000, $42
	.byte %11111111, $00

Cherry1Shape
	.byte %01100000, $e6
	.byte %00010000, $e6
	.byte %00001000, $e6
	.byte %00001000, $e6
	.byte %00011000, $44
	.byte %00111100, $44
	.byte %00011000, $44
	.byte %11111111, $00

Banana1Shape
	.byte %00011000, $f6
	.byte %00001100, $1a
	.byte %00001110, $1a
	.byte %00001110, $1a
	.byte %00001110, $1a
	.byte %00011100, $1a
	.byte %00110000, $1a
	.byte %11111111, $00

Drink1Shape
	.byte %00000010, $0c
	.byte %00000100, $0c
	.byte %01111110, $ac
	.byte %01001010, $ac
	.byte %01010010, $ac
	.byte %01111110, $ac
	.byte %00111100, $ac
	.byte %11111111, $00

CandyBar1Shape
	.byte %01111000, $0f
	.byte %11001100, $42
	.byte %11001100, $0f
	.byte %00001100, $42
	.byte %00001100, $0f
	.byte %00001100, $42
	.byte %00001100, $0f
	.byte %11111111, $00

Player1Shape
;	.byte 2, 4	; Numero frames animazione, velocita' animazione (delay in frames)
; Frame 1
	.byte %01011010, $82
	.byte %10111101, $86
	.byte %01111110, $8a
	.byte %11011011, $8a
	.byte %11011011, $8a
	.byte %01111110, $8a
	.byte %10111101, $86
	.byte %01011010, $82
; Frame 2
	.byte %01011010, $82
	.byte %10111101, $86
	.byte %01111110, $8a
	.byte %11100111, $8a
	.byte %11100111, $8a
	.byte %01111110, $8a
	.byte %10111101, $86
	.byte %01011010, $82

PlayerExplosion1Shape	; Deve essere consecutivo a Player1Shape
	.byte %01011010, $82
	.byte %10111101, $86
	.byte %01100110, $8a
	.byte %11000011, $8a
	.byte %11000011, $8a
	.byte %01100110, $8a
	.byte %10111101, $86
	.byte %01011010, $82

	.byte %10011001, $82
	.byte %00100100, $86
	.byte %01000010, $8a
	.byte %10011001, $8a
	.byte %10011001, $8a
	.byte %01000010, $8a
	.byte %00100100, $86
	.byte %10011001, $82

	.byte %00011000, $82
	.byte %00000000, $86
	.byte %00011000, $8a
	.byte %10100101, $8a
	.byte %10100101, $8a
	.byte %00011000, $8a
	.byte %00000000, $86
	.byte %00011000, $82

	.byte %00000000, $82
	.byte %00011000, $86
	.byte %00000000, $8a
	.byte %01000010, $8a
	.byte %01000010, $8a
	.byte %00000000, $8a
	.byte %00011000, $86
	.byte %00000000, $82

	.byte %00011000, $82
	.byte %00000000, $86
	.byte %00000000, $8a
	.byte %10000001, $8a
	.byte %10000001, $8a
	.byte %00000000, $8a
	.byte %00000000, $86
	.byte %00011000, $82

PlayerGround1Shape
	.byte %01011010, $82
	.byte %10111101, $86
	.byte %01111110, $8a
	.byte %11100111, $8a
	.byte %11100111, $8a
	.byte %01111110, $8a
	.byte %10000001, $0d
	.byte %01111110, $0d

	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %10000001, $0d
	.byte %01111110, $0d

Blank1Shape
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00


NumbersShape
Number0
	.byte %01111110
	.byte %11000011
	.byte %11000011
	.byte %11000011
	.byte %11000011
	.byte %11000011
	.byte %11000011
	.byte %01111110
Number1
	.byte %00011000
	.byte %00111000
	.byte %01111000
	.byte %00011000
	.byte %00011000
	.byte %00011000
	.byte %00011000
	.byte %11111111
Number2
	.byte %01111110
	.byte %11000011
	.byte %00000110
	.byte %00001100
	.byte %00011000
	.byte %00110000
	.byte %01100000
	.byte %11111111
Number3
	.byte %01111110
	.byte %11000011
	.byte %11000011
	.byte %00001110
	.byte %01100011
	.byte %11000011
	.byte %11000011
	.byte %01111110
Number4
	.byte %00011000
	.byte %00110000
	.byte %00110000
	.byte %01100011
	.byte %01100011
	.byte %11000011
	.byte %11111111
	.byte %00000011
Number5
	.byte %11111111
	.byte %11000000
	.byte %11000000
	.byte %11111110
	.byte %00000011
	.byte %00000011
	.byte %11000011
	.byte %01111110
Number6
	.byte %01111110
	.byte %11000011
	.byte %11000000
	.byte %11111110
	.byte %11000011
	.byte %11000011
	.byte %11000011
	.byte %01111110
Number7
	.byte %11111111
	.byte %00000011
	.byte %00000110
	.byte %00000110
	.byte %00001100
	.byte %00001100
	.byte %00011000
	.byte %00011000
Number8
	.byte %01111110
	.byte %11000011
	.byte %11000011
	.byte %01111110
	.byte %11000011
	.byte %11000011
	.byte %11000011
	.byte %01111110
Number9
	.byte %01111110
	.byte %11000011
	.byte %11000011
	.byte %11000011
	.byte %01111111
	.byte %00000011
	.byte %11000011
	.byte %01111110

Player1Anim	; numero frames, offset frame n, offset frame n-1, .. , offset frame 1
	.byte 16, 16, 16, 16, 16, 16, 16, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0

PlayerDeath1Anim
	.byte 40
	.byte 96, 96, 96, 96
	.byte 96, 96, 96, 96
	.byte 80, 80, 80, 80
	.byte 80, 80, 80, 80
	.byte 64, 64, 64, 64
	.byte 64, 64, 64, 64
	.byte 48, 48, 48, 48
	.byte 48, 48, 48, 48
	.byte 32, 32, 32, 32
	.byte 32, 32, 32, 32

LevelData1
; Fromato: 0,NUSIZ1,ShapeHIGH,ShapeLOW
; Legge dal fondo quindi l'ultimo e' la prima riga
; NUSIZ1: 0=1 sprite  6=3 distanti
; Il primo shape e' quello della fascia piu' in basso, l'ultimo e' il frutto

; Level 1
	.byte 0,6,>Rock1Shape, <Rock1Shape, 0,6,>Ball1Shape, <Ball1Shape, 0,6,>Cube1Shape, <Cube1Shape, 0,6,>Ship1Shape, <Ship1Shape, 0,6,>Ufo1Shape, <Ufo1Shape, 0,6,>Mine1Shape, <Mine1Shape, 0,0,>Strawberry1Shape, <Strawberry1Shape
	.byte 0,6,>Rock1Shape, <Rock1Shape, 0,6,>Ball1Shape, <Ball1Shape, 0,6,>Cube1Shape, <Cube1Shape, 0,6,>Ship1Shape, <Ship1Shape, 0,6,>Ufo1Shape, <Ufo1Shape, 0,6,>Mine1Shape, <Mine1Shape, 0,0,>Vertical1Shape, <Vertical1Shape
LevelData2
	.byte 0,6,>Circle1Shape, <Circle1Shape, 0,6,>Ball1Shape, <Ball1Shape, 0,6,>Cube1Shape, <Cube1Shape, 0,6,>Ship1Shape, <Ship1Shape, 0,6,>Star1Shape, <Star1Shape, 0,6,>Rock1Shape, <Rock1Shape, 0,0,>Cherry1Shape, <Cherry1Shape
	.byte 0,6,>Circle1Shape, <Circle1Shape, 0,6,>Ball1Shape, <Ball1Shape, 0,6,>Cube1Shape, <Cube1Shape, 0,6,>Ship1Shape, <Ship1Shape, 0,6,>Star1Shape, <Star1Shape, 0,6,>Rock1Shape, <Rock1Shape, 0,0,>Star1Shape, <Star1Shape
LevelData3
	.byte 0,6,>Circle1Shape, <Circle1Shape, 0,6,>Ball1Shape, <Ball1Shape, 0,6,>Cube1Shape, <Cube1Shape, 0,6,>Ship1Shape, <Ship1Shape, 0,6,>Ufo1Shape, <Ufo1Shape, 0,6,>Mine1Shape, <Mine1Shape, 0,0,>CandyBar1Shape, <CandyBar1Shape
	.byte 0,6,>Circle1Shape, <Circle1Shape, 0,6,>Ball1Shape, <Ball1Shape, 0,6,>Cube1Shape, <Cube1Shape, 0,6,>Ship1Shape, <Ship1Shape, 0,6,>Ufo1Shape, <Ufo1Shape, 0,6,>Mine1Shape, <Mine1Shape, 0,0,>Rock1Shape, <Rock1Shape

EnemyMoves1	; Delay in frames del movimento nemici, Byte da addizionare (puo' essere negativo
	; Level 1
	.byte $01, $02, $03, $01, $02, $03, $04	; Al solito inizia a leggere dal fondo quindi l'ultimo byte corrisponde al primo nemico in alto
EnemyMoves2	; Level 2
	.byte $01, $01, $02, $03, $01, $03, $04
EnemyMoves3
	.byte $01, $02, $01, $02, $02, $01, $03

EnemyDirections1	; Level 1
	.byte 1, -1, 1, 1, -1, -1, 1
EnemyDirections2	; Level 2
	.byte -1, 1, -1, -1, 1, 1, -1
EnemyDirections3
	.byte 1, 1, -1, -1, 1, -1, 1

EnemyPositions	; Posizioni X iniziali delle fasce - Bug: se lo sprite parte da 00 e va a sinistra, sparisce...
	.byte $01, $11, $21, $31, $41, $51, $61
	.byte 0,0	; Pad a 16 bytes per saltare facilmente il livello...

BgFirstLine
	.byte $42, $00, $00, $00, $00, $00, $00, $00

LevelPointers
	.byte >LevelData1, <LevelData1
	.byte >LevelData2, <LevelData2
	.byte >LevelData3, <LevelData3

EnemyMovesPointers
	.byte >EnemyMoves1, <EnemyMoves1
	.byte >EnemyMoves2, <EnemyMoves2
	.byte >EnemyMoves3, <EnemyMoves3

EnemyDirectionsPointers
	.byte >EnemyDirections1, <EnemyDirections1
	.byte >EnemyDirections2, <EnemyDirections2
	.byte >EnemyDirections3, <EnemyDirections3

IntroPfColors
	.byte $00, $76, $78, $7a, $78, $76, $74, $72

	ORG $FF00
DrawIntroScreen
DrawIntroScreenLoop1
	LDA INTIM
	BNE DrawIntroScreenLoop1 ; Whew!
	STA WSYNC
	STA VBLANK  ;End the VBLANK period with a zero.
	LDA PF_Reflect
	STA CTRLPF  ; set playfield to reflect - G.S.
	LDA #0
	;
	STA COLUP0
	STA COLUP1; blacking out player colors
	LDA #$00 ; set playfield color to deep red
	STA COLUPF
	STA PFColorRAM
	;
	LDA #191 
	STA ScanLine
;	LDA #6
;	STA ScanPix
;	TAY
	LDY #6

	LDX #30
	LDA #0
	STA PF0
	STA PF1
	STA PF2

VPosition
	STA WSYNC
	DEC ScanLine
	DEX
	BNE VPosition
	;

	LDX #7

	LDA #$34 ; set playfield color to deep red
	STA COLUPF
ScanLoopIntroScreen
;	DEC ScanPix
	DEY
	BNE ScanGoIntroScreen
;	LDA #5
;	STA ScanPix
	LDY #5
	DEX			;next big pixel line
;	BNE ScanGoIntroScreen
;	JMP EndOfIntroScreen1
	BEQ EndOfIntroScreen1
ScanGoIntroScreen
	STA WSYNC
	LDA IntroPfColors,X
	STA COLUPF
	;
	; Time to begin cycle counting
	;
	LDA PFData0,X           ;[0]+4
	STA PF0                 ;[4]+3 = *7*   < 23	;PF0 visible
	
	LDA PFData1,X           ;[7]+4
	STA PF1                 ;[11]+3 = *14*  < 29	;PF1 visible
	
	LDA PFData2,X           ;[14]+4
	STA PF2                 ;[18]+3 = *21*  < 40	;PF2 visible

;	nop			;[21]+2
;	nop			;[23]+2
;	nop			;[25]+2
	;six cycles available  Might be able to do something here
	
	LDA PFData0b,X          ;[27]+4

	;PF0 no longer visible, safe to rewrite
	STA PF0                 ;[31]+3 = *34* 

	LDA PFData1b,X		;[34]+4

	;PF1 no longer visible, safe to rewrite
	STA PF1			;[38]+3 = *41*  

	LDA PFData2b,X		;[41]+4
	
	;PF2 rewrite must begin at exactly cycle 45!!, no more, no less
	STA PF2			;[45]+2 = *47*  ; > 46 PF2 no longer visible

	;76-47 = 29 cycles left per scanline available for
	; further calculations (i.e. sprites), not counting the rest of the
	; existing code below that branches off and changes the indexing to the letter graphics

	;nop adding even this one nop, however, breaks this kernel!
	;-Glenn Saunders
	
	DEC ScanLine
	BNE ScanLoopIntroScreen

EndOfIntroScreen1
	;
	LDA #$00 ; set playfield color to deep red
	STA COLUPF

	LDY #123
EndIntroScreenLoop
	DEY
	STA WSYNC
	BNE EndIntroScreenLoop

	LDA #2
	STA WSYNC  ;Finish scanline 192.
	STA VBLANK ; Make TIA output invisible,
	;
	LDY #0
	STY PF0
	STY PF1
	STY PF1
	STY GRP0
	STY GRP1
	STY ENAM0
	STY ENAM1
	STY ENABL

;OverScanIntroScreen
;	LDX #30
;KillLinesIntroScreen
;	STA WSYNC
;	DEX
;	BNE KillLinesIntroScreen

;	JMP DrawIntroScreen
	RTS

; --- Intro Screen Graphics ---
;               REFLECTED PLAYFIELD
;   PF0|   PF1  |  PF2   |   PF2b |   PF1b |PF0b|
;  4567|76543210|01234567|76543210|01234567|7654|

PFData0  ;D       4 5 6 7
;	.byte $00, $30, $40, $40, $20, $10, $10, $60
	.byte $00, $70, $80, $80, $40, $20, $20, $C0

PFData1  ;EA      7 6 5 4 3 2 1 0
;	.byte $00, $8A, $8A, $8A, $CE, $AA, $AA, $C4
	.byte $00, $45, $45, $45, $47, $65, $15, $E2

PFData2  ;TH      0 1 2 3 4 5 6 7
;	.byte $00, $66, $11, $11, $31, $11, $11, $66
	.byte $00, $CC, $22, $22, $62, $22, $02, $FC

PFData2b ;DE   76543210;<--- scanning order
;	.byte $00, $4A, $4A, $4A, $4C, $4A, $4A, $EC
	.byte $00, $25, $25, $25, $26, $25, $21, $7E
	
PFData1b;RB    01234567;<--- scanning order
;	.byte $00, $56, $51, $51, $73, $51, $51, $26
	.byte $00, $AC, $A2, $A2, $E6, $A2, $A2, $4C

PFData0b;Y     7654    ;<--- scanning order
;	.byte $00, $40, $40, $40, $40, $40, $40, $E0
	.byte $00, $20, $20, $20, $20, $20, $20, $70
	
; -----------------------------

;enemyDelays = $xx	; Array of MAX_STRIPES con i delay di EnemyMoves (uno per Stripe)
;enemyPos = $xx	; Array of MAX_STRIPES con i POS dei nemici, precalcolati (uno per Stripe)
;enemyOff = $xx	; Array of MAX_STRIPES con gli OFFset dei nemici, precalcolati (uno per Stripe)
;enemyX = $xx	; Array of MAX_STRIPES che ovviamente contiene le X dei nemici (una per Stripe)
; Totale: 32 bytes :( (diventeranno probabilemente 24 se riduco gli Stripes a 7)

;
; Graphics are placed so that the extra cycle in the PFData,X indexes
; is NEVER taken, by making sure it never has to index across a page
; boundary.  This way our cycle count holds true.
;

;	org $FF00 ; *********************** GRAPHICS DATA

;
; This is the tricky part of drawing a playfield: actually
; drawing it.  Well, the display routine and all that binary
; math was a bit tricky, too, but still, listen up.
;
; Playfield data isn't stored the way most bitmaps are, even
; one-dimensional bitmaps.  We will use the left side of the
; screen only, knowing that the right side is either repeated
; or reflected from it.
;
; In PF0 and PF2, the most significant bit (bit 7) is on the RIGHT
; side.  In PF1, the most significant bit is on the LEFT side.  This
; means that relative to PF0 and PF2, PF1 has a reversed bit order.
; It's just really weird.
;
;    PF0  |     PF1       |      PF2
;  4 5 6 7|7 6 5 4 3 2 1 0|0 1 2 3 4 5 6 7
;
; This is important to remember when doing calculations on bytes intended
; for the PF registers.  Defender gives a good example of this.
;
; It will become necessary to write a program that makes this easier,
; because it is easy to become confused when dealing with this system.
;

;ShiftTab ; 16
;	.byte $80, $90, $a0, $b0, $c0, $d0, $e0, $f0, $00, $10, $20, $30, $40, $50, $60, $70

	org $FFFC
	.word Start
	.word Start

; Letters: R
; Direction: <- (quindi flip anche sulle X)
; .byte $00, $f0, $00, $a0, $60, $e0, $a0, $e0
; 
; 00000000
; 11110000
; 00000000
; 10100000
; 01100000
; 11100000
; 10100000
; 11100000
; 
; Letters: AS
; Direction: -> (flip solo sulle Y)
; .byte $00, $ff, $00, $57, $51, $77, $54, $77
; 
; 00000000
; 11111111
; 00000000
; 01010111
; 01010001
; 01110111
; 01010100
; 01110111
; 
; Letters: TY
; Direction: <- (quindi flip anche sulle X)
; .byte $00, $ff, $00, $44, $44, $e4, $a4, $ae
; 
; 00000000
; 11111111
; 00000000
; 01000100
; 01000100
; 11100100
; 10100100
; 10101110


